local string = string
local table = table
local Debug = Debug
local Effect = Effect
local Duel = Duel
local Card = Card
local s = {}
s["效卡之类排"] = {
TYPE_SPELL
, TYPE_TRAP
, TYPE_EFFECT
}
s["无效灵摆怪兽之卡编排"] = {
28363749
, 19474136
, 17390179
, 83980492
}
s["全区"] = LOCATION_HAND + LOCATION_MZONE + LOCATION_SZONE + LOCATION_GRAVE + LOCATION_REMOVED + LOCATION_DECK + LOCATION_EXTRA
do
  local h1
  --~ 则对
  h1 = {
  [3] = "大师3 "
  , [4] = "新大师 "
  , [5] = "大师2020 "
  }
  s["Debug.ReloadFieldBegin"] = _G.Debug.ReloadFieldBegin
  --~ 模
  --~ 则数
  function _G.Debug.ReloadFieldBegin(u1, u2)
    s["伪洗卡"] = u1 & DUEL_PSEUDO_SHUFFLE
    s["战段"] = u1 & DUEL_ATTACK_FIRST_TURN
    s["机智"] = u1 & DUEL_SIMPLE_AI
    if u2 then
      s["则"] = h1[u2]
    else
      s["则"] = h1[5]
      end
    s["Debug.ReloadFieldBegin"](u1, u2)
    end
  end
s["不被连锁"] = function()
  Duel.SetChainLimit(aux.FALSE)
  return true
  end
do
  local h1, h2
  --~ 原解邀请
  h1 = "残局群181175613"
  --~ 二解邀请，备用：圣魔术师
  h2 = "爆貘团：「你居然二解了，请加群告诉我怎么二解。」"
    --~ 通关邀
  s["_通关邀"] = function()
    local h3
    --~ 对方之血
    h3 = Duel.GetLP(1)
    if h3 <= 0 then
      if h3 == 0 then
        Debug.ShowHint(h1)
      else
        Debug.ShowHint(h2)
        end
      end
    end
  s["通关邀"] = function()
    local h1
    --~ 效果
    h1 = Effect.GlobalEffect()
    h1:SetType(EFFECT_TYPE_FIELD + EFFECT_TYPE_CONTINUOUS)
    h1:SetCode(EVENT_DAMAGE)
    h1:SetCondition(s["_通关邀"])
    h1:SetOperation(aux.NULL)
    Duel.RegisterEffect(h1, 0)
    end
  end
s["是否效卡"] = function(card)
  for i = 1, #s["效卡之类排"] do
    if Card.IsType(card, s["效卡之类排"][i]) then
      return true
      end
    end
  if Card.IsType(card, TYPE_PENDULUM) then
    for i = 1, #s["无效灵摆怪兽之卡编排"] do
      if Card.IsCode(card, s["无效灵摆怪兽之卡编排"][i]) then
      else
        return true
        end
      end
    end
  end
do
  local h1
  --~ “调该效果”的效果
  --~ “调该效果”的玩家
  s["_开局选卡入手"] = function(u1, u2)
    local h2
    --~ 玩家选定的卡
    h2 = Duel.SelectMatchingCard(u2, Card.IsAbleToHand, u2, LOCATION_DECK, 0, h1, h1, nil)
    Duel.SendtoHand(h2, nil, REASON_RULE)
    u1:Reset()
    end
  s["开局选卡入手"] = function(u1)
    local h2
    s["「开局选卡入手」之量"] = u1
    --~ 「开局选卡入手」之量
    h1 = u1
    --~ 效果
    h2 = Effect.GlobalEffect()
    h2:SetType(EFFECT_TYPE_FIELD + EFFECT_TYPE_CONTINUOUS)
    h2:SetCode(EVENT_ADJUST)
    h2:SetCondition(aux.TRUE)
    h2:SetOperation(s["_开局选卡入手"])
    Duel.RegisterEffect(h2, 0)
    end
  end
--~ 「禁主怪格」之几个
s["「禁主怪格」之几个"] = function(u1)
  local h1
  s["「禁主怪格」之量"] = u1
  --~ 效果
  h1 = Effect.GlobalEffect()
  h1:SetCode(EFFECT_USE_EXTRA_MZONE)
  h1:SetValue(u1)
  Duel.RegisterEffect(h1, 0)
  end
--~ 「禁魔陷格」之几个
s["「禁魔陷格」之几个"] = function(u1)
  local h1
  s["「禁魔陷格」之量"] = u1
  --~ 效果
  h1 = Effect.GlobalEffect()
  h1:SetCode(EFFECT_USE_EXTRA_SZONE)
  h1:SetValue(u1)
  Duel.RegisterEffect(h1, 0)
  end
do
  s["Debug.ReloadFieldEnd"] = _G.Debug.ReloadFieldEnd
  --~ 「禁主怪格」之几个
  --~ 「禁魔陷格」之几个
  function _G.Debug.ReloadFieldEnd(u1, u2)
    s["Debug.ReloadFieldEnd"]()
    if u1 then
      s["「禁主怪格」之几个"](u1)
      end
    if u2 then
      s["「禁魔陷格」之几个"](u2)
      end
    end
  end
do
  local h1, h2, h3, h4
  --~ 印卡过多之示
  h1 = "印卡过多"
  --~ 现之印卡数
  h2 = 1
  --~ 印手卡之上限
  h3 = 0
  --~ 总印卡之上限
  h4 = 0
  --~ 「调该效果」的效果
  --~ 「调该效果」的玩家
  s["_印卡"] = function(u1, u2)
    local h5, h6
    --~ 印卡之卡编
    h5 = Duel.AnnounceCard(u2)
    --~ 卡
    h6 = Duel.CreateToken(u2, h5)
    if h2 <= h3 then
      h2 = h2 + 1
      Duel.SendtoHand(h6, nil, REASON_RULE)
    else
      if h2 <= h4 then
        h2 = h2 + 1
        Duel.SendtoDeck(h6, u2, 0, REASON_RULE)
      else
        Debug.ShowHint(h1)
        u1:Reset()
        end
      end
    end
  s["印卡"] = function(u1, u2, u3)
    local h5, h6
    h3 = u2
    h4 = u3 or u2
    Debug.ShowHint("点对方额外卡组，可印卡\n只能印手卡" .. h3 .. "张\n最多可印" .. h4 .. "张")
    h5 = Effect.CreateEffect(u1)
    h5:SetType(EFFECT_TYPE_IGNITION)
    h5:SetProperty(EFFECT_FLAG_BOTH_SIDE + EFFECT_FLAG_UNCOPYABLE + EFFECT_FLAG_CANNOT_NEGATE + EFFECT_FLAG_CANNOT_DISABLE)
    h5:SetTarget(s["不被连锁"])
    h5:SetRange(LOCATION_EXTRA)
    h5:SetOperation(s["_印卡"])
    u1:RegisterEffect(h5)
    end
  end
s["开局示"] = function()
  local h1, h2, h3
  --~ 此局效卡之数
  h2 = Duel.GetMatchingGroupCount(s["是否效卡"], 0, s["全区"], s["全区"], nil)
  --~ 超量材组
  h3 = Duel.GetOverlayGroup(0, LOCATION_MZONE, LOCATION_MZONE)
  for u1 in aux.Next(h3) do
    if s["是否效卡"](u1) then
      h2 = h2 + 1
      end
    end
  --~ 开局说明
  h1 = h2 .. "卡 " .. s["则"]
  if s["伪洗卡"] == 0 then
  else
    h1 = h1 .. "伪洗卡 "
    end
  if s["战段"] == 0 then
    h1 = h1 .. "无战段 "
    end
  if s["机智"] == 0 then
    h1 = h1 .. "无机智 "
    end
  if s["「开局选卡入手」之量"] then
    h1 = h1 .. "选" .. s["「开局选卡入手」之量"] .. "卡 "
    end
  if s["「禁主怪格」之量"] then
    h1 = h1 .. "禁" .. s["「禁主怪格」之量"] .. "怪格 "
    end
  if s["「禁魔陷格」之量"] then
    h1 = h1 .. "禁" .. s["「禁魔陷格」之量"] .. "魔格 "
    end
  Debug.ShowHint(h1)
  end
do
  s["aux.BeginPuzzle"] = _G.aux.BeginPuzzle
  --~ 「开局选卡入手」之量
  --~ 传入对方额外卡组最上面表侧卡，并将其作为印卡源
  --~ 能印手卡几张
  --~ 最多能印卡几张
  function _G.aux.BeginPuzzle(u1, u2, u3, u4)
    s["aux.BeginPuzzle"]()
    if u1 then
      s["开局选卡入手"](u1)
      end
    if u2 then
      s["印卡"](u2, u3, u4)
    else
      end
    s["开局示"]()
    s["通关邀"]()
    end
  end
